﻿
#   Script PowerShell.
#   Recherche des vues Image dans un projet PTE AV Sutdio 10 le 01/09/2019.
#   Dernière version du 25/05/2020 
#   Mise à jour du 10-04-2023 pour PTE 10.5 et PTE 11, en N&B, bof pour le pot de peinture de Windows.
#   Auteur : Gérard DUCHEIN.
    
    Clear-Host
    $host.ui.RawUI.WindowTitle = "Synthèse de projet / PTE AV Studio 10   " + ((get-date).toString("f")).ToUpper()
    Write-Host

#   -----  Chargement de l'assemblage Système Formes Windows
    
    [System.Reflection.Assembly]::LoadWithPartialName("System.Windows.Forms") | Out-Null

#   -----  Séléction du fichier PTE
	
    $Obj_Form = New-Object System.Windows.Forms.OpenFileDialog
	$Obj_Form.InitialDirectory = "E:\Documents\Mes Diaporamas\PTE"
	$Obj_Form.Filter = "PicturesToExe|*.pte"
	$Obj_Form.Title  = ((get-date).toString("f")).ToUpper()+"  - Sélection du Fichier source PTE"
	$Dialogue = $Obj_Form.ShowDialog()

	If ($Dialogue -eq "OK")
	    {
		  $NomFichier= $Obj_Form.FileName
	    }
	Else
	    {
          break
        }

    $NomFic_txt = $NomFichier.Replace('pte', 'txt')
   
#   -----  Gestion fichier 

    If ((Test-Path $NomFic_txt) -eq $True){Remove-Item -Path $NomFic_txt -Recurse}

    ADD-content -path $NomFic_txt -value " "

#   -----  Compatibilité PTE_10 ou ultérieure

    $Version_PTE = (Select-String $NomFichier -Pattern "filetype=" -Context 0,0) 
    $Version_PTE = ("$Version_PTE").Trim()
    $J = ("$Version_PTE").IndexOf("=") + 1
    $Version_PTE= $Version_PTE.SubString($J)
    if ($Version_PTE -ne "Project file of PTE AV Studio")
       {
        $Reponse=[System.Windows.Forms.MessageBox]::Show("Le fichier PTE n'est pas en Version 10 ou ultérirure. Quitter.", "   Version PTE" ,"Ok",16)
        if($Reponse -eq "OK"){exit} else {exit}
	   }
    Write-Host  (" "*3 + ((get-date).toString("f")).ToUpper()); Write-Host  
    ADD-content $NomFic_txt -value (" "*3 + ((get-date).toString("f")).ToUpper())
    ADD-content $NomFic_txt -value " "
    ADD-Content $NomFic_txt -value "   Fichiers à traiter"
    ADD-content $NomFic_txt -value " "
    ADD-Content $NomFic_txt -value ("   "+$NomFichier + "  <<<")
    ADD-Content $NomFic_txt -value ("   "+$NomFic_txt + "  >>>")
    ADD-content $NomFic_txt -value " "
    
#   -----  $Nombre de lignes du fichier source PTE

    $Lignes = (Get-Content $NomFichier).Count
     

#   -----  Nom du projet PTE.

    try
    {
    $Nom_du_Projet= (Select-String $NomFichier -Pattern "opt_exefn=" -Context 0,0)
    $Nom_du_Projet = "$Nom_du_Projet".Trim()
    $J = "$Nom_du_Projet".LastIndexOf("\") + 1
    $i = "$Nom_du_Projet".LastIndexOf(".")
    $Nom_du_Projet = $Nom_du_Projet.Substring($J,($i-$J))
    }
    catch
    {$Nom_du_Projet = "Sans nom"}
    
    Write-Host "   PROJET PTE :  "$Nom_du_Projet
    Write-Host
    Write-Host "   Fichiers à traiter"
    Write-Host "  " $NomFichier "<<<"
    Write-Host "  " $NomFic_txt ">>>"
    Write-Host
    
    ADD-content $NomFic_txt -value " "
    ADD-content $NomFic_txt -value ("   PROJET PTE :  " + $Nom_du_Projet + "   -  " + "{0,6}" -f $Lignes + " lignes")
    ADD-content $NomFic_txt -value " "

#   -----  Nombre de Vues du Projet PTE.

    $Nombre_Vues = (Select-String $NomFichier -Pattern "opt_slidescount=" -Context 0,0)
    $Nombre_Vues = ("$Nombre_Vues").Trim()
    $Nombre_Vues = $Nombre_Vues.Substring(("$Nombre_Vues").LastIndexOf("=") + 1)

    Write-Host "   Nombre de lignes : " $Lignes
    Write-Host "   ─────────────────────────────────────────────────────"
    Write-Host

    $Global:reponse = $Null  
    $Reponse = [System.Windows.Forms.MessageBox]::Show("Un fichier texte sera créé et ouvert avec NotePad. Voulez-vous une liste à l'écran ?", "Liste des vues" , "YesNo", 64)

#   -----  Recherche des vues

    Write-Host "   Recherche des vues en cours"; Write-Host
    $i   = 1
    $ii  = 0
    [int]$Vue = 0
    $Ch1 = $null
    $Ch2 = $null
    $x   = $null
    $g   = @(); $v=@()
    $g   = $null; $v = $null
   

    Foreach ($x in Get-Content($NomFichier))
    {
        if ((Get-Culture).TextInfo.ToTitleCase($x).contains("[Slide"))
           {
                $Vue = $x.subString(0,$x.length-1).subString($x.subString(0,$x.length-1).IndexOf("e")+1)
                $Ch1 = (" "*3 + "{0,6}" -f $i + " "*4 + "│"+ " "*3  + "[Slide " + "{0,3}" -f $Vue + "]")
                $i++
                Continue
           }
        elseif ($x.contains("ImageName=%effects%"))
           {
                $i++; Continue
           }
        elseif ($x.contains("object")-and $x.contains(":Video"))
           {
                $ii++
                For($q = $i + 1;$q -lt $i + 15;$q++) 
                   {
                      if ($x.contains("FileName=")-and $x.IndexOf("\")-gt 0)
                         {
                            $Ch2 = " "+ "{0,6}" -f $i + "  │ Vidéo " + ($x.Substring($x.LastIndexOf("\") + 1)); break
                         }
                      $x = Get-Content($NomFichier) | Select-Object -Index $q
                   }
                $i++
                Switch($Reponse){"Yes"{Write-Host  ($Ch1 + "`t"*1 + "│   " + $Ch2)}"No"{}}
                ADD-content $NomFic_txt -value ($Ch1 + "`t"*1 + "│  " + $Ch2)
                Continue
           }
        elseif ($x.contains("ImageName=")-and $x.IndexOf("\")-gt 0)
           {
                $Ch2 = " "+ "{0,6}" -f $i + "  │       " + $x.Substring($x.LastIndexOf("\") + 1)
                $i++
                Switch($Reponse){"Yes"{Write-Host  ($Ch1 + "`t"*1 + "│   " + $Ch2)}"No"{}}
                ADD-content $NomFic_txt -value ($Ch1 + "`t"*1 + "│  " + $Ch2)
                Continue
           }
        elseif ($x.contains("LinkedAudio=") -and $x.Length -gt 12)
           {
                  [int]$j = -26
                  [int]$k = 1
                  Do
                  {
                    $j = $j+38
                    $g += ,@($x.SubString($j,38)); $v += ,@($Vue)
                    $k++
                  } While ($k -le ([int]($x.Length - 12)/38))
                  $i++
                  Continue
           }
        elseif ($Vue -eq $Nombre_Vues-and $x -match '^end') 
           {   
                break 
           }
        else 
           {
               $i++
           }
    }
    Write-Host
    Write-Host "   Terminé..."
    Write-Host

#   -----  Recherche de(s) vue(s) vide(s) 

    Write-Host; Write-Host  "   Recherche des vue(s) vide(s) contenues dans ce projet"; Write-Host
    ADD-content $NomFic_txt -value " "; ADD-content $NomFic_txt -value "   Vue(s) 'vide(s)' contenue(s) dans ce projet."; ADD-content $NomFic_txt -value " "

    $i = 0
    $t = @()
    $j = 0
    $Ch1 = $Null
    $y   = $Null
    [int]$Vue = 0
    $Slide_End = $false

    Foreach ($y in Get-Content($NomFichier))
    {
        $i++ 
        if ((Get-Culture).TextInfo.ToTitleCase($y).contains("[Slide"))
           {
              $Slide_End = $true
              $j = $i
              $Vue = $y.subString(0,$y.length-1).subString($y.subString(0,$y.length-1).IndexOf("e")+1)
              $Ch1 = "   " + "{0,6}" -f $i + " "*4 + "│"+ " "*3  + "[Slide " + "{0,3}" -f $Vue + "]"
           }
        if ($y.contains("object Container:Root") -and $Slide_End)
           {
              $y = Get-Content -Path $Nomfichier | Select-Object -Index $i
              if ($y.contains("end") -or $y.contains(":Box") -or $y.contains(":Text")) 
                 {    
                   Switch($Reponse){"Yes"{Write-Host ($Ch1 + "`t"*1 + "│    "  + "{0,6}" -f $j + "  │       Vue vide")}"No"{}}
                   $t += ($Ch1 + "`t" + "`t" + " "*8 +"│   "  + "{0,6}" -f $i + "  Vue vide")
                   ADD-content $NomFic_txt -value ($Ch1 + "`t"*1 + "│   "  + "{0,6}" -f $j + "  │       Vue vide")
                   $Slide_End = $false
                   if ($Vue -eq $Nombre_Vues-and $x -match '^end')  {break}   
                 }
           }
    }

    Write-Host; Write-Host  "   Terminé..."; Write-Host
    Write-Host; Write-Host ("   Nombre de vues du projet : " + $Nombre_Vues + " dont " + $t.count + " 'vues vide(s)'"); Write-Host
    Write-Host ("   Nombre de vidéo(s) du projet : " + "{0,3}" -f $ii)
    ADD-content $NomFic_txt -value " "
    ADD-Content $NomFic_txt -value ("   Nombre de vues du projet : " + $Nombre_Vues + " dont " + $t.count +" 'vue(s) vide(s)'")
    ADD-Content $NomFic_txt -value ("   Nombre de vidéo(s) du projet : " + "{0,3}" -f $ii)
    ADD-content $NomFic_txt -value " "    
    ADD-content $NomFic_txt -value ("   Colonne 1 : Numéro de ligne du fichier source PTE " + $NomFichier)
    ADD-content $NomFic_txt -value ("   Colonne 2 : Numéro des vues [Slide xxx]")
    ADD-content $NomFic_txt -value ("   Colonne 3 : Numéro de ligne du fichier source PTE où le fichier image est chargé")
    ADD-content $NomFic_txt -value ("   Colonne 4 : Nom du fichier image/vidéo contenu dans la vue")

#   -----  Recherche fichier(s) son 
  
    $b1 = 0; $b2 = 0; $b3 = 0; $i = 0
    $a  = @()
   
#   -----  Bloc object Music:Music - Pistes 

    Write-Host;Write-Host (" "*3 + "Recherche piste(s) son"); Write-Host (" "*3 + "En cours..."); Write-Host

    Foreach ($y in Get-Content($NomFichier))
    {
        $i++
        if ($y -match '^object Music:Music' -eq $true)
           {
              $y = Get-Content -Path $Nomfichier | Select-Object -Index ($i-1)
              $b1 = $i # Début de bloc - object Music:Music
              $b3 = $i
              continue
           }

        if ($y -match '^end' -eq $true) 
           {  
              $y = Get-Content -Path $Nomfichier | Select-Object -Index ($i-1)
              $b2 = $i # Fin de bloc   - end
              break
           }
    }

    $p = "  object Track?:TMusicTrack"
    $i = 0 
    $a = $null
    Do
    {
        $x  = Get-Content -Path $Nomfichier| Select-Object -Index ($b1)
        if ($x -match ($p.replace("?",$i)) -eq $true)
           {
              $y  = Get-Content -Path $Nomfichier| Select-Object -Index ($b1+1)
              if ($y -match 'FileName=' -eq $true) {$q = $y.Substring($y.IndexOf("=") + 1)} else {$q="Sans nom"}
              $l  = (" "*3 + "{0,6}" -f ($b1+1) + " "*4 + "│ Piste " + "{0,2}" -f ($i+1) + " " + $q)
              $a +=,@($l)
              $i++ 
              $b1 = $b1+10
           }
        else {$b1++}
    } Until ($b1 -gt $b2)

    $l  = (" "*3 + "{0:D6}" -f ($b2) + " "*4 + "│ Piste 00 ────")
    $a += ,@($l)

#   -----  Si pas de piste(s) son on quitte.

    if( $a.count -eq 1){ Write-Host (" "*3 + "Pas de piste(s) son"); Write-Host}
    if( $a.count -eq 1){ $a = $null; Start-Process -FilePath "Notepad " $NomFic_txt; exit}

#   -----  Si oui on continue

    Switch($Reponse){"Yes"{Write-host ""; Write-Host ("   Piste(s) son du projet (" +  ($a.count-1) + ")");Write-Host ""}"Cancel"{}}
    Switch($Reponse){"Yes"{$a[0..([int]$a.count-2)] | ForEach-Object {Write-Host $_}} "Cancel"{}}

    ADD-content $NomFic_txt -value " "
    ADD-Content $NomFic_txt -value ("   Piste(s) son du projet (" + "{0,2}" -f $a.count[0..($a.count-1)] + ")")
    ADD-content $NomFic_txt -value " "
    ADD-Content $NomFic_txt -value $a[0..([int]$a.count-2)]
    ADD-content $NomFic_txt -value " "
    Write-host ""

#   -----  Recherche de fichier(s) son 

    Write-Host; Write-Host (" "*3 + "Recherche fichier(s) son"); Write-Host (" "*3 + "En cours...")
    
    $j  = $a.Count; $i=0; $x = $null; $y = $null; $t = $null
    $b1 = $b3
    $t  = @() 
    #$t +=,@(" "*3 + "Fichier(s) son du projet")
    $f  = 0
    $a1 = 0                  

    Do
    {
        try {
        $t += ,@("")
        $t += ,@(" "*3 + $a[$i].SubString(15))
        $lu = [int]$a[$i].SubString(3,6)
        $li = [int]$a[$i+1].SubString(3,6)
        }catch{}
        $k  = 0
        $q  = "    object Item?:TMusicItem"
        Do
        {
          $x = Get-Content -Path $Nomfichier | Select-Object -Index ($lu)
          if ($x -match ($q.replace("?",$k))-eq $false) 
             {$lu++; continue}
          else
             {
               $e = $null
               $y = Get-Content -Path $Nomfichier | Select-Object -Index ($lu+1)
               if (-not ([string]::IsNullOrEmpty($g)) -and -not ([string]::IsNullOrEmpty($v)))
               {
                  For ($j=0; $j -le $g.count;$j++)
                      {
                        if ($y.SubString($y.IndexOf("=")+1) -eq $g[$j]){$e = "...attaché vue " + "{0:D3}" -f $v[$j];$a1++}
                      }
               }
               $y  = Get-Content -Path $Nomfichier | Select-Object -Index ($lu+2)
               $l  = (" "*3 + "{0,6}" -f ($lu+1) + " "*4 + "│ N° " + "{0,2}" -f ($k+1) + " " + $y.Substring($y.LastIndexOf("\")+1) + $e)
               $t += ,@($l)
               $lu = $lu + 4;  $k++ ;$f++
             }
        } Until ($lu -gt $li)
        $i++        
    } Until ($i -gt [int]$a.count -2)


    Switch($Reponse){"Yes"{$t | ForEach-Object {Write-Host $_}} "Cancel"{}}

    ADD-content $NomFic_txt -value " "
    ADD-Content $NomFic_txt -value $t
    ADD-Content $NomFic_txt -value " "
    ADD-Content $NomFic_txt -value (" "*7 + "{0,2}" -f $f  +" fichier(s) son répertorié(s) pour le projet dont,")
    ADD-Content $NomFic_txt -value (" "*7 + "{0,2}" -f $a1 +" attaché(s) à une vue")

#   -----  Terminé
 
    Write-Host
    Switch($Reponse){"Yes"{Write-Host(" "*7 + "{0,2}" -f $f  +" fichier(s) son répertorié(s) pour le projet dont,");Write-Host} "Cancel"{}}
    Switch($Reponse){"Yes"{Write-Host(" "*7 + "{0,2}" -f $a1 +" attaché(s) à une vue");Write-Host} "Cancel"{}}
    Write-Host
    Write-Host (" "*3 + "Terminé.")
    Write-Host

#   -----  Notepad
 
    Start-Process -FilePath "Notepad" $NomFic_txt  